<?xml version="1.0" encoding="UTF-8"?>

<!-- Copyright 2005-2022 Joël Krähemann <jkraehemann@gmail.com> -->
<!-- Copying and distribution of this file, with or without modification, -->
<!-- are permitted in any medium without royalty provided the copyright -->
<!-- notice and this notice are preserved. This file is offered as-is, -->
<!-- without any warranty. -->

<component type="desktop">
  <id>org.nongnu.gsequencer.gsequencer</id>
  <metadata_license>FSFAP</metadata_license>
  <project_license>GPL-3.0-or-later</project_license>
  <content_rating type="oars-1.0">
    <content_attribute id="social-audio">none</content_attribute>
  </content_rating>
  <name>GSequencer</name>
  <summary>Advanced Gtk+ Sequencer</summary>
  <description>
    <p>GSequencer provides you various tools to play, create, edit and mix your own music.
    It features a step sequencer, piano roll, automation and wave-form editor.</p>
  </description>
  
  <launchable type="desktop-id">gsequencer.desktop</launchable>

  <screenshots>
    <screenshot type="default">
      <caption>GSequencer's main window</caption>
      <image>https://directory.fsf.org/w/images/2/26/Gsequencer-piano-roll-with-drum.png</image>
    </screenshot>
    <screenshot>
      <caption>GSequencer's automation window</caption>
      <image>https://directory.fsf.org/w/images/4/4f/Gsequencer-automation-mixer.png</image>
    </screenshot>
    <screenshot>
      <caption>GSequencer's wave window</caption>
      <image>https://directory.fsf.org/w/images/3/34/Gsequencer-wave-audiorec.png</image>
    </screenshot>
  </screenshots>

  <url type="homepage">https://nongnu.org/gsequencer</url>

  <releases>
    <release version="3.18.2" date="2022-02-22">
      <description>
	<p>
	  Fixed application ID.
	</p>
      </description>
    </release>

    <release version="3.18.0" date="2022-02-22">
      <description>
	<p>
	  Implemented AgsMetaDataWindow.
	</p>
	<p>
	  Implemented GtkHeaderBar.
	</p>
      </description>
    </release>

    <release version="3.17.7" date="2022-02-15">
      <description>
	<p>
	  Minor improvements.
	</p>
      </description>
    </release>

    <release version="3.17.5" date="2022-02-12">
      <description>
	<p>
	  Minor improvements.
	</p>
      </description>
    </release>

    <release version="3.17.0" date="2022-02-06">
      <description>
	<p>
	  Implemneted AgsSFZSynth.
	</p>
      </description>
    </release>

    <release version="3.16.14" date="2022-01-29">
      <description>
	<p>
	  Fixed AgsSF2Synth potential SIGSEGV because of uninitialized field.
	</p>
      </description>
    </release>
    
    <release version="3.16.11" date="2022-01-22">
      <description>
	<p>
	  Minor improvements.
	</p>
      </description>
    </release>

    <release version="3.16.8" date="2022-01-20">
      <description>
	<p>
	  Fixed proper failure of missing plugins during reading of AgsSimpleFile.
	</p>
	<p>
	  Fixed ref-count of plugin in ags-fx-ladspa, ags-fx-dssi, ags-fx-lv2 and ags-fx-vst3.
	</p>
      </description>
    </release>

    <release version="3.16.7" date="2022-01-19">
      <description>
	<p>
	  Improved restore from XML notify about failure of instantiating machines eg. missing lugins.
	</p>
      </description>
    </release>

    <release version="3.16.5" date="2022-01-15">
      <description>
	<p>
	  Fixed AgsFFPlayer restore from XML.
	</p>
      </description>
    </release>

    <release version="3.16.3" date="2022-01-14">
      <description>
	<p>
	  Fixed missing Lv2 plugins.
	</p>
      </description>
    </release>

    <release version="3.16.1" date="2022-01-13">
      <description>
	<p>
	  Implemented AgsSF2Synth.
	</p>
	<p>
	  Minor improvements.
	</p>
      </description>
    </release>

    <release version="3.16.0" date="2022-01-12">
      <description>
	<p>
	  Implemented AgsSF2Synth.
	</p>
	<p>
	  Minor improvements.
	</p>
      </description>
    </release>

    <release version="3.15.6" date="2022-01-09">
      <description>
	<p>
	  Fixed synths.
	</p>
      </description>
    </release>

    <release version="3.15.4" date="2022-01-08">
      <description>
	<p>
	  Fixed AgsCompositeEditor when machine changed to restore automation ports.
	</p>
      </description>
    </release>

    <release version="3.15.3" date="2022-01-08">
      <description>
	<p>
	  Fixed AgsSynthUtil and AgsFMSynthUtil missing scale.
	</p>
      </description>
    </release>

    <release version="3.15.2" date="2022-01-08">
      <description>
	<p>
	  Fixed configure event with notation, automation and wave form editors. The scrollbar
	  value is modified to match new upper boundary.
	</p>
	<p>
	  Fixed ags-fx-peak and on macOS broken utility functions to calculate peak.
	</p>
      </description>
    </release>

    <release version="3.15.1" date="2022-01-06">
      <description>
	<p>
	  Fixed AgsHybridFMSynth missing OSC 3.
	</p>
      </description>
    </release>

    <release version="3.15.0" date="2022-01-06">
      <description>
	<p>
	  Implemented AgsHybridFMSynth powered by ags-fx-fm-synth.
	</p>
      </description>
    </release>

    <release version="3.14.10" date="2021-12-27">
      <description>
	<p>
	  Fixed corrupted selection list of notation, automation and wave form.
	</p>
      </description>
    </release>

    <release version="3.14.9" date="2021-12-26">
      <description>
	<p>
	  Fixed wave form editor selection.
	</p>
      </description>
    </release>

    <release version="3.14.8" date="2021-12-26">
      <description>
	<p>
	  Fixed wave form editor paste from clipboard.
	</p>
	<p>
	  Fixed AgsHybridSynth XML write of sync attack and phase.
	</p>
      </description>
    </release>

    <release version="3.14.5" date="2021-12-22">
      <description>
	<p>
	  Fixed automation editor to respect lower value correctly, integer and toggled ports.
	</p>
      </description>
    </release>

    <release version="3.14.4" date="2021-12-22">
      <description>
	<p>
	  Fixed missing automation for fx effect processors.
	</p>
      </description>
    </release>

    <release version="3.14.2" date="2021-12-21">
      <description>
	<p>
	  Implemented AgsHybridSynth powered by ags-fx-synth. Yay, a new synth is born.
	</p>
      </description>
    </release>

    <release version="3.13.3" date="2021-12-09">
      <description>
	<p>
	  Fixed SIGSEGV while terminating.
	</p>
      </description>
    </release>

    <release version="3.13.1" date="2021-12-06">
      <description>
	<p>
	  Fixed wave form editor clipboard.
	</p>
      </description>
    </release>

    <release version="3.11.7" date="2021-09-11">
      <description>
	<p>
	  Fixed soundcard thread left in error status with alsa after
	  intialization failed.
	</p>
      </description>
    </release>
    
    <release version="3.11.4" date="2021-09-09">
      <description>
	<p>Improved plugin loading from AgsXorgApplicationContext by timeout.</p>
      </description>
    </release>

    <release version="3.11.2" date="2021-09-07">
      <description>
	<p>Fixed restore from XML.</p>
      </description>
    </release>
 
    <release version="3.11.1" date="2021-09-07">
      <description>
	<p>Fixed SIGSEGV after destroy AgsLiveVstBridge.</p>
      </description>
    </release>

    <release version="3.11.0" date="2021-09-07">
      <description>
	<p>Fixed VST3 parallelism.</p>
      </description>
    </release>
    
    <release version="3.10.18" date="2021-09-05">
      <description>
	<p>Fixed playback of AgsLiveVst3Bridge.</p>
      </description>
    </release>

    <release version="3.10.12" date="2021-08-31">
      <description>
	<p>Implemented VST3 plugin browser.</p>
      </description>
    </release>
    
    <release version="3.10.8" date="2021-08-30">
      <description>
	<p>Improved VST3 unicode support.</p>
      </description>
    </release>

    <release version="3.10.5" date="2021-08-29">
      <description>
	<p>First VST3 plugin support.</p>
      </description>
    </release>

    <release version="3.10.4" date="2021-08-25">
      <description>
	<p>
	  Improved default scale size of AgsMatrix, AgsSyncsynth, AgsFMSyncsynth, AgsFFPlayer
	  and AgsPitchSampler.
	</p>
	<p>Improved allow (null) as WASAPI device</p>
      </description>
    </release>

    <release version="3.9.0" date="2021-06-21">
      <description>
	<p>Implemented pitch function to select within UI.</p>
      </description>
    </release>

    <release version="3.8.12" date="2021-06-12">
      <description>
	<p>New functions added with Fluidsynth power.</p>
      </description>
    </release>

    <release version="3.8.11" date="2021-06-02">
      <description>
	<p>fixed ags_hq_pitch_util.c wrong interpolate factor, affecting AgsFFPlayer and AgsPitchSampler.</p>
      </description>
    </release>
    
    <release version="3.8.10" date="2021-04-09">
      <description>
	<p>improved hq pitch util.</p>
      </description>
    </release>

    <release version="3.8.9" date="2021-04-09">
      <description>
	<p>minor improvements.</p>
      </description>
    </release>

    <release version="3.8.8" date="2021-04-09">
      <description>
	<p>fixed ags-fx-lfo default values.</p>
	<p>fixed wrong tuning AgsSF2SynthGenerator and AgsSFZSynthGenerator.</p>
      </description>
    </release>

    <release version="3.8.6" date="2021-04-05">
      <description>
	<p>improved AgsPluginBrowser proper reset.</p>
      </description>
    </release>

    <release version="3.8.5" date="2021-04-02">
      <description>
	<p>fixed ags_lfo_synth_util.c offset and iteration.</p>
      </description>
    </release>

    <release version="3.8.3" date="2021-03-31">
      <description>
	<p>fixed missing store of AgsFFPlayer and AgsPitchSampler aliase.</p>
	<p>fixed missing store of AgsSyncsynth, AgsFMSyncsynth, AgsMatrix, AgsFFPlayer and AgsPitchSampler volume.</p>
      </description>
    </release>

    <release version="3.7.50" date="2021-03-16">
      <description>
	<p>fixed missing loop information after map recall.</p>
      </description>
    </release>

    <release version="3.7.49" date="2021-03-16">
      <description>
	<p>fixed missing loop information after machine added.</p>
      </description>
    </release>

    <release version="3.7.48" date="2021-03-08">
      <description>
	<p>updated user's handbook chapter 2.</p>
      </description>
    </release>

    <release version="3.7.47" date="2021-03-07">
      <description>
	<p>minor improvements.</p>
      </description>
    </release>

    <release version="3.7.46" date="2021-03-06">
      <description>
	<p>minor improvements.</p>
      </description>
    </release>

    <release version="3.7.45" date="2021-03-03">
      <description>
	<p>minor improvements.</p>
      </description>
    </release>

    <release version="3.7.44" date="2021-02-27">
      <description>
	<p>fixed potential SIGSEGV with AgsPluginBrowser no plugin selected.</p>
      </description>
    </release>

    <release version="3.7.43" date="2021-02-22">
      <description>
	<p>Added Polish translation.</p>
      </description>
    </release>

    <release version="3.7.42" date="2021-02-21">
      <description>
	<p>Fixed uninitialized buffer of AgsFxPeakChannel.</p>
      </description>
    </release>

    <release version="3.7.41" date="2021-02-20">
      <description>
	<p>Fixed ref-count of add/remove soundcard task.</p>
      </description>
    </release>

    <release version="3.7.40" date="2021-02-18">
      <description>
	<p>Fixed ref-count after reading audio file.</p>
      </description>
    </release>

    <release version="3.7.39" date="2021-02-18">
      <description>
	<p>Improved stability.</p>
      </description>
    </release>

    <release version="3.7.38" date="2021-02-16">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.7.37" date="2021-02-13">
      <description>
	<p>Fixed AgsServer missing 403 Forbidden response.</p>
      </description>
    </release>

    <release version="3.7.36" date="2021-02-13">
      <description>
	<p>Apple macOS specific optimizations using Accelerate Framework to do vector arithmetic.</p>
      </description>
    </release>

    <release version="3.7.35" date="2021-02-09">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.7.34" date="2021-02-07">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>
    
    <release version="3.7.32" date="2021-01-30">
     <description>
	<p>Fixed ghost playback after unlink running machine.</p>
	<p>Improved pulseaudio thread-safety.</p>
      </description>
    </release>

    <release version="3.7.30" date="2021-01-25">
      <description>
	<p>Fixed LADSPA and Lv2 plugin restore as line member.</p>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.7.29" date="2021-01-25">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.7.27" date="2021-01-23">
      <description>
	<p>Fixed AppStream XML.</p>
      </description>
    </release>

    <release version="3.7.26" date="2021-01-23">
      <description>
	<p>Fixed oscillator doesn't auto-update after restore from XML.</p>
	<p>Updated GSequencer screenshots in AppStream XML.</p>
	<p>minor improvements.</p>
      </description>
    </release>

    <release version="3.7.25" date="2021-01-14">
      <description>
	<p>Fixed lower XML parsing of AgsFMSynth.</p>
	<p>Fixed bank-0 and bank-1 XML parsing of AgsDrum and AgsMatrix.</p>
      </description>
    </release>

    <release version="3.7.24" date="2021-01-12">
      <description>
	<p>Added French language support.</p>
      </description>
    </release>

    <release version="3.7.23" date="2021-01-10">
      <description>
	<p>Added German language support.</p>
      </description>
    </release>

    <release version="3.7.22" date="2021-01-03">
      <description>
	<p>Fixed AgsTurtle accessing string after free.</p>
      </description>
    </release>

    <release version="3.7.21" date="2021-01-02">
      <description>
	<p>Fixed potential unitiailized pointer.</p>
      </description>
    </release>

    <release version="3.7.20" date="2021-01-02">
      <description>
	<p>Fixed ags-fx-envelope be explicite about floating point arithmetic.</p>
      </description>
    </release>

    <release version="3.7.19" date="2020-12-25">
      <description>
	<p>Fixed missing listing of developer's handbook.</p>
      </description>
    </release>
    
    <release version="3.7.18" date="2020-12-24">
      <description>
	<p>Improved developer's handbook.</p>
      </description>
    </release>

    <release version="3.7.17" date="2020-12-22">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.7.16" date="2020-12-21">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.7.15" date="2020-12-20">
      <description>
	<p>Added CSS style to htmlhelp books.</p>
      </description>
    </release>

    <release version="3.7.14" date="2020-12-20">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.7.13" date="2020-12-20">
      <description>
	<p>Improved user's book images to have default width 1920 pixels.</p>
      </description>
    </release>

    <release version="3.7.9" date="2020-12-17">
      <description>
	<p>Updated developer's book chap10.xml.</p>
      </description>
    </release>
    
    <release version="3.7.8" date="2020-12-13">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.7.4" date="2020-12-07">
      <description>
	<p>Fixed effects on output.</p>
      </description>
    </release>

    <release version="3.7.3" date="2020-12-06">
      <description>
	<p>Improved SF2 support to select nearest sample.</p>
	<p>Improved SFZ support.</p>
      </description>
    </release>

    <release version="3.7.0" date="2020-12-03">
      <description>
	<p>Fixed pitch loudness.</p>
      </description>
    </release>

    <release version="3.6.29" date="2020-11-27">
      <description>
	<p>Improved notation, automation and wave editor to do proper GUI scale.</p>
      </description>
    </release>

    <release version="3.6.28" date="2020-11-26">
      <description>
	<p>Fixed meson build.</p>
      </description>
    </release>

    <release version="3.6.22" date="2020-11-24">
      <description>
	<p>Fixed upper of AgsNotationEditor's AgsRuler.</p>
      </description>
    </release>

    <release version="3.6.21" date="2020-11-24">
      <description>
	<p>Improved notation, automation and wave editor to do proper GUI scale.</p>
      </description>
    </release>

    <release version="3.6.20" date="2020-11-23">
      <description>
	<p>Fixed missing restore of pattern envelope.</p>
      </description>
    </release>
    
    <release version="3.6.19" date="2020-11-23">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.6.18" date="2020-11-23">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.6.17" date="2020-11-23">
      <description>
	<p>Fixes to ags-fx-envelope.</p>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.6.16" date="2020-11-20">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.6.15" date="2020-11-15">
      <description>
	<p>Fixed gui-scale factor applied to AgsRuler.</p>
      </description>
    </release>

    <release version="3.6.14" date="2020-11-09">
      <description>
	<p>Fixed AgsPlayback cleanup.</p>
      </description>
    </release>

    <release version="3.6.10" date="2020-11-08">
      <description>
	<p>Fixed memory corruption in Ags*DssiBridge and Ags*Lv2Bridge.</p>
      </description>
    </release>

    <release version="3.6.9" date="2020-11-07">
      <description>
	<p>Many bug-fixes to configure AgsAudioSignal.</p>
	<p>Implemented lock-free ags-fx-playback.</p>
	<p>Fixed missing mutex.</p>
      </description>
    </release>

    <release version="3.6.8" date="2020-11-06">
      <description>
	<p>Fixed AgsWindow delete-event callback to use AgsQuitDialog.</p>
      </description>
    </release>

    <release version="3.6.7" date="2020-11-04">
      <description>
	<p>Fixed pthread remains.</p>
      </description>
    </release>

    <release version="3.6.6" date="2020-11-03">
      <description>
	<p>Added some getter/setter functions to AgsPiano.</p>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.6.5" date="2020-11-01">
      <description>
	<p>Added Gstreamer env variables on mingw64.</p>
      </description>
    </release>
    
    <release version="3.6.4" date="2020-10-31">
      <description>
	<p>Fixed missing return value of AgsWindow's button_press_event() callback</p>
      </description>
    </release>

    <release version="3.6.3" date="2020-10-31">
      <description>
	<p>Fixed pthread remains.</p>	
      </description>
    </release>

    <release version="3.6.2" date="2020-10-29">
      <description>
	<p>Implemented fast pitch.</p>	
	<p>Refactored ags_sf2_synth_util.c.</p>
	<p>Refactored ags_sfz_synth_util.c.</p>
      </description>
    </release>

    <release version="3.6.1" date="2020-10-25">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.6.0" date="2020-10-25">
      <description>
	<p>Implemented gstreamer file IO.</p>
      </description>
    </release>

    <release version="3.5.16" date="2020-10-05">
      <description>
	<p>Fixed missing AgsMutable interface of ags-fx-volume.</p>
      </description>
    </release>

    <release version="3.5.15" date="2020-10-05">
      <description>
	<p>Fixed NULL pointer dereference while setting initial loop.</p>
	<p>Fixed missing update of LV2_Options_Option after config changed.</p>
      </description>
    </release>

    <release version="3.5.14" date="2020-09-26">
      <description>
	<p>Fixed missing initial loop, loop start and loop end set of instruments.</p>
      </description>
    </release>

    <release version="3.5.13" date="2020-09-24">
      <description>
	<p>Fixed AgsDssiBridge accessing integer as string.</p>
      </description>
    </release>

    <release version="3.5.12" date="2020-09-18">
      <description>
	<p>Fixed missing reset of notation edit's horizontal scrollbar after zoom changed.</p>
      </description>
    </release>

    <release version="3.5.11" date="2020-09-18">
      <description>
	<p>Fixed shrink audio channels.</p>
      </description>
    </release>

    <release version="3.5.10" date="2020-09-16">
      <description>
	<p>Implemented plugin filename fallback to different location.</p>
      </description>
    </release>

    <release version="3.5.9" date="2020-09-13">
      <description>
	<p>Fixed tempo issue.</p>
      </description>
    </release>

    <release version="3.5.8" date="2020-07-31">
      <description>
	<p>Fixed ags_audiorec_fast_export().</p>
      </description>
    </release>

    <release version="3.5.7" date="2020-07-26">
      <description>
	<p>Fixed fast export.</p>
      </description>
    </release>

    <release version="3.5.5" date="2020-07-19">
      <description>
	<p>Fixed memory-leak causing performance impact.</p>
	<p>Fixed missing restore of some AgsFMSyncsynth controls.</p>
      </description>
    </release>

    <release version="3.5.4" date="2020-07-18">
      <description>
	<p>Fixed missing icons in online help.</p>
      </description>
    </release>

    <release version="3.5.2" date="2020-07-16">
      <description>
	<p>Fixed missing expand of WebView of online help.</p>
      </description>
    </release>
    
    <release version="3.5.1" date="2020-07-16">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.5.0" date="2020-07-15">
      <description>
	<p>Implemented improved AgsQuitDialog.</p>
	<p>Implemented improved AgsOnlineHelpWindow with navigation.</p>
      </description>
    </release>

    <release version="3.4.14" date="2020-07-10">
      <description>
	<p>Minor changes.</p>
      </description>
    </release>
    
    <release version="3.4.13" date="2020-07-05">
      <description>
	<p>Improved stability.</p>
      </description>
    </release>

    <release version="3.4.11" date="2020-07-04">
      <description>
	<p>Improved speed of AgsSF2SynthGenerator and AgsSFZSynthGenerator.</p>
      </description>
    </release>

    <release version="3.4.10" date="2020-07-01">
      <description>
	<p>Improved ags_sf2_synth_util.c and ags_sfz_synth_util.c.</p>
      </description>
    </release>

    <release version="3.4.9" date="2020-06-27">
      <description>
	<p>Improved pitch to compute phase using floating point modulo.</p>
      </description>
    </release>

    <release version="3.4.8" date="2020-06-25">
      <description>
	<p>Fixed immediate frequency.</p>
      </description>
    </release>

    <release version="3.4.7" date="2020-06-25">
      <description>
	<p>Improved pitch's immediate frequency to be an octave in ags_filter_util.c.</p>
      </description>
    </release>

    <release version="3.4.5" date="2020-06-23">
      <description>
	<p>Improved filter util to use projection during 2nd pitch rewrite.</p>
      </description>
    </release>

    <release version="3.4.2" date="2020-06-20">
      <description>
	<p>Fixed potential division by zero in filter util.</p>
      </description>
    </release>

    <release version="3.4.1" date="2020-06-19">
      <description>
	<p>Fixed missing clear synth generator.</p>
      </description>
    </release>

    <release version="3.4.0" date="2020-06-19">
      <description>
	<p>Implemented SF2 and SFZ synth generator.</p>
      </description>
    </release>

    <release version="3.3.15" date="2020-06-10">
      <description>
	<p>Improved ags-fx-playback.</p>
      </description>
    </release>

    <release version="3.3.14" date="2020-06-09">
      <description>
	<p>Improved automation editor.</p>
	<p>Added ags-fx-volume to AgsPanel.</p>
      </description>
    </release>

    <release version="3.3.13" date="2020-06-09">
      <description>
	<p>Fixed missing automation of ags-fx-volume.</p>
      </description>
    </release>

    <release version="3.3.10" date="2020-05-31">
      <description>
	<p>More fixes to AgsAudiorec.</p>
      </description>
    </release>

    <release version="3.3.9" date="2020-05-29">
      <description>
	<p>Fixed AgsAudiorec capture.</p>
      </description>
    </release>

    <release version="3.3.8" date="2020-05-27">
      <description>
	<p>Fixed AgsSpectrometer visualization.</p>
      </description>
    </release>

    <release version="3.3.6" date="2020-05-22">
      <description>
	<p>Fixed potential SIGSEGV as modifying buffer-size of AgsSpectrometer.</p>
      </description>
    </release>

    <release version="3.3.5" date="2020-05-22">
      <description>
	<p>More fixes to MIDI playback.</p>
      </description>
    </release>

    <release version="3.3.4" date="2020-05-21">
      <description>
	<p>Fixed MIDI playback.</p>
	<p>Fixed AgsSyncsynth and AgsFmSyncsynth playback.</p>
      </description>
    </release>

    <release version="3.3.3" date="2020-05-19">
      <description>
	<p>Fixed infinite loop while removing AgsLineMember from AgsEffectLine.</p>
      </description>
    </release>
    
    <release version="3.3.2" date="2020-05-19">
      <description>
	<p>Fixed potential dead-lock.</p>
	<p>Fixed reverse mapping of DSSI and LV2 plugins.</p>
      </description>
    </release>

    <release version="3.3.0" date="2020-05-18">
      <description>
	<p>Refactored GSequencer to use new fx recalls to do audio processing.</p>
      </description>
    </release>

    <release version="3.2.15" date="2020-04-16">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="3.2.14" date="2020-04-14">
      <description>
	<p>Fixed potential NULL pointer dereference.</p>
	<p>Fixed wrong midi-end-mapping of AgsSimpleFile.</p>
      </description>
    </release>

    <release version="3.2.13" date="2020-04-13">
      <description>
	<p>Fixed greedy DSSI and LV2.</p>
      </description>
    </release>

    <release version="3.2.12" date="2020-04-13">
      <description>
	<p>Fixed AgsFFPlayer restore.</p>
	<p>Improved startup time as loading LV2 plugins.</p>
      </description>
    </release>
    
    <release version="3.2.10" date="2020-04-09">
      <description>
	<p>Faster load of AgsMachineEditor.</p>
      </description>
    </release>

    <release version="3.2.8" date="2020-04-08">
      <description>
	<p>Improved LV2 scanner.</p>
      </description>
    </release>

    <release version="3.2.6" date="2020-04-07">
      <description>
	<p>Fixed AgsLiveLv2Bridge and AgsLiveDssiBridge to handle note-on properly.</p>
      </description>
    </release>

    <release version="3.2.5" date="2020-04-05">
      <description>
	<p>Implemented LV2_OPTIONS__options feature.</p>
      </description>
    </release>

    <release version="3.2.2" date="2020-03-30">
      <description>
	<p>Implemented additional getter/setter functions of AgsGui.</p>
      </description>
    </release>

    <release version="3.2.0" date="2020-03-13">
      <description>
	<p>Disabled GMainLoop integration of AgsTaskLauncher in AgsXorgApplicationContext.</p>
      </description>
    </release>

    <release version="3.1.1" date="2020-02-04">
      <description>
	<p>Updated the user manual.</p>
      </description>
    </release>

    <release version="3.1.0" date="2020-02-04">
      <description>
	<p>Implemented meta widgets of notation, automation and wave editor.</p>
	<p>Implemented acoustic feedback of DSSI and LV2.</p>
	<p>Fixed automation editor not showing again after machine changed.</p>
	<p>Minor improvements</p>
      </description>
    </release>

    <release version="3.0.8" date="2020-01-23">
      <description>
	<p>Fixes to WASAPI backend.</p>
	<p>Fixes to CoreAudio backend.</p>
      </description>
    </release>

    <release version="3.0.5" date="2020-01-19">
      <description>
	<p>Improved pulseaudio connect timeout.</p>
      </description>
    </release>

    <release version="3.0.4" date="2020-01-16">
      <description>
	<p>Fixed potential SIGSEGV.</p>
	<p>Fixed potential data-race.</p>
      </description>
    </release>
    
    <release version="3.0.1" date="2020-01-14">
      <description>
	<p>Fixed potential recursive callback.</p>
	<p>Fixed potential data-race.</p>
      </description>
    </release>

    <release version="3.0.0" date="2020-01-14">
      <description>
	<p>Migrated to Gtk-3.</p>
	<p>Migrated to GIO socket API.</p>
	<p>Migrated to GThread API.</p>
	<p>Migrated to Libsoup2.4 API.</p>
	<p>Implemented AgsAudiorec's fast export.</p>
	<p>Implemented GObject-Introspection support.</p>
	<p>Improved AgsSpectrometer resolution.</p>
	<p>Improved MIDI import/export.</p>
	<p>Improved performance.</p>
      </description>
    </release>

    <release version="2.4.8" date="2019-12-27">
      <description>
	<p>
	  Implemented GObject-Introspection annotations, enjoy the new GIRs.
	</p>
	<p>
	  Implemented AgsServer XMLRPC based authentication using XML files with
	  session cookie support. There is a new dependency on Libsoup2.4.
	</p>
	<p>
	  Implemented AGS-OSC-OVER-XMLRPC allowing you to encapsule OSC packets in
	  your XMLRPC request. Response is handled by WebSockets.
	</p>
	<p>
	  Migrated from Gtk+-2.0 to Gtk+-3.0.
	</p>
	<p>
	  Migrated from POSIX to GThread API.
	</p>
	<p>
	  Major API changes.
	</p>
	<p>
	  Supporting LLVM's clang compiler. Replaced nested functions GNU C extension.
	</p>
	<p>
	  Fixed some potential SIGSEGVs.
	</p>
      </description>
    </release>

    <release version="2.4.6" date="2019-12-27">
      <description>
	<p>Implemented ags_audio_buffer_resample_with_buffer() and related.</p>
	<p>Fixed potential buffer-overflow in ags_sfz_sample.c.</p>
	<p>Fixed potential SIGSEGV in ags_sound_resource.c during resample.</p>
      </description>
    </release>

    <release version="2.4.5" date="2019-12-18">
      <description>
	<p>minor improvements.</p>
      </description>
    </release>
    
    <release version="2.4.4" date="2019-12-17">
      <description>
	<p>Fixed potential SIGSEGV of AgsFFPlayer adding plugin.</p>
	<p>Fixed accessing freed memory of AgsBulkMember.</p>
      </description>
    </release>

    <release version="2.4.3" date="2019-12-07">
      <description>
	<p>Minor improvements.</p>
      </description>
    </release>
    
    <release version="2.3.15" date="2019-10-20">
      <description>
	<p>Fixed AgsAudiorec open audio files with different samplerate.</p>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="2.3.12" date="2019-10-11">
      <description>
	<p>Improved AgsPitchSampler and fixed persistence.</p>
	<p>Minor improvements.</p>
      </description>
    </release>

    <release version="2.3.2" date="2019-09-10">
      <description>
        <p>Implemented new machines AgsFMSynth, AgsFMSyncsynth and AgsPitchSampler.</p>
	<p>New impulse oscillator wave.</p>
      </description>
    </release>

    <release version="2.2.36" date="2019-08-07">
      <description>
        <p>Faster iterating on buffer in ags_audio_buffer_util.c.</p>
      </description>
    </release>

    <release version="2.2.35" date="2019-08-06">
      <description>
        <p>Replaced regular expression in ags_turtle_read_pn_chars_base().</p>
      </description>
    </release>

    <release version="2.2.34" date="2019-08-05">
      <description>
        <p>Improved AgsReturnableThread safety.</p>
      </description>
    </release>

    <release version="2.2.33" date="2019-08-03">
      <description>
        <p>Fixed various memory-leaks.</p>
      </description>
    </release>

    <release version="2.2.31" date="2019-07-31">
      <description>
        <p>Fixed uninitialized values.</p>
      </description>
    </release>

    <release version="2.2.22" date="2019-07-18">
      <description>
        <p>Implemented GUI scale factor.</p>
      </description>
    </release>

    <release version="2.2.9" date="2019-07-02">
      <description>
        <p>Improved LV2 logarithmic conversion.</p>
      </description>
    </release>

    <release version="2.2.7" date="2019-06-29">
      <description>
        <p>Improved check if LV2 plugin port already exists.</p>
      </description>
    </release>

    <release version="2.2.0" date="2019-06-17">
      <description>
        <p>Improved LV2 RDF Turtle parser.</p>
      </description>
    </release>

    <release version="2.1.77" date="2019-06-17">
      <description>
        <p>Fixed potential SIGSEGV during restore from XML in ags_simple_file.c.</p>
      </description>
    </release>

    <release version="2.1.76" date="2019-06-12">
      <description>
        <p>Improved mutexes.</p>
      </description>
    </release>

    <release version="2.1.74" date="2019-06-01">
      <description>
        <p>Fixed some memory-leaks.</p>
	<p>Fixed potential SIGSEGV during restore from XML in ags_simple_file.c.</p>
      </description>
    </release>
  </releases>
</component>
